import room, foe, data, thing

class dungeon:
  def __init__(self, name):
    self.name = name
    self.loaddata()
    self.startup()
  def loaddata(self):
    f = data.load("dungeon", self.name + ".dat")
    lines = [line[0:-1] for line in f]
    self.room0, self.e0, self.dend = [int(a) for a in lines[0].split(" ")]
    self.musicname = lines[1]
    self.roomdata = []
    for line in lines[2:]:
      d = line.split(" ")
      if len(d) < 9: continue
      rname = d[0]
      rdialog = int(d[1])
      rexits = [(int(d[j]), int(d[j+1])) for j in (2, 4, 6, 8)]
      rfoes = d[10:]
      self.roomdata.append([rname, rdialog, rexits, rfoes])
  def startup(self):
    self.currentroomn, self.e = self.room0, self.e0
    try:
      f = data.load("savegame.dat")
      for line in f:
        if not "|" in line: continue
        dname, r, e = line[:-1].split("|")
        if dname == self.name:
          self.currentroomn, self.e = int(r), 0
    except IOError:
      pass
    self.loadroom()
  def getdialog(self):
    d = self.roomdata[self.currentroomn][1]
    self.roomdata[self.currentroomn][1] = -1
    return d
  def issave(self):
    return "start" in self.roomdata[self.currentroomn][0]
  def savegame(self):
    try:
      f = data.load("savegame.dat")
      lines = [line for line in f.readlines() if self.name not in line]
      f.close()
    except IOError:
      lines = []
    lines.append("%s|%d|%d\n" % (self.name, self.currentroomn, self.e))
    f = data.load("savegame.dat", None, "w")
    for line in lines: f.write(line)
    f.close()
  def loadroom(self):
    name, dialog, exits, foes = self.roomdata[self.currentroomn]
    if self.issave():  # Save point
      self.savegame()
    self.room = room.Room(name)
    self.foe = []
    for j in range(len(foes)):
      p = self.room.patrol[j]
      if foes[j] == "s":
        s = foe.scorp(p[0])
        s.setpatrol(p)
        self.foe.append(s)        
      if foes[j] == "b":
        s = foe.boar(p[0])
        s.setpatrol(p)
        self.foe.append(s)
      if foes[j] == "m":
        s = foe.mine(p[0])
        s.setpatrol(p)
        self.foe.append(s)
    if self.currentroomn + 1 == len(self.roomdata):
      if self.name == "larry":
        self.foe.append(thing.larry(self.room.entrance[1]))
      elif self.name == "morgan":
        self.foe.append(thing.morgan(self.room.entrance[1]))
      elif self.name == "adelpaite":
        self.foe.append(thing.adelpaite(self.room.entrance[1]))
      elif self.name == "azcoatl":
        self.foe.append(thing.azcoatl(self.room.entrance[1]))
      elif self.name == "sisters":
        for j in (1, 2, 3):
          self.foe.append(thing.sister(self.room.entrance[j]))
      elif self.name == "grigori":
        self.foe.append(thing.grigori(self.room.entrance[1]))
      elif self.name == "priscilla":
        self.foe.append(thing.priscilla(self.room.entrance[1]))
    self.entrance = self.room.entrance[self.e]
  def win(self):
    return self.currentroomn + 1 == len(self.roomdata) and not self.foe
  def exitroom(self, direction):
    exits = self.roomdata[self.currentroomn][2]
    self.currentroomn, self.e = exits[direction]
    if self.currentroomn >= 0: self.loadroom()
  def setwin(self):
    self.currentroomn = -1
    self.savegame()



