# This is mah enumy class!

import thing, rimage, random, sound
from thing import *
from random import *

class foe(thing):
  def setpatrol(self, psteps):
    self.psteps = psteps
    self.jpatrol = randint(0, len(self.psteps) - 1)
    j, k = self.jpatrol, (self.jpatrol + 1) % len(self.psteps)
    (x0, y0), (x1, y1) = self.psteps[j], self.psteps[k]
    r = uniform(0, 1)
    self.setpos((x0 * r + x1 * (1-r), y0 * r + y1 * (1-r)))
    self.patrolling = True
  def attack(self, you):
    if you.tharm: return False
    self.attacking = self.atime
    you.harm(1, self)
    self.pursuit = False
  def update(self, dt, you, room):
    if self.humming:
      dt *= 3
    if not self.tsleep and not self.attacking and collide(self, you):
      self.attack(you)
    if not self.tsleep and not self.pursuit and not self.attacking:
      if you.visible and not you.tharm and self.cansee(you.pos, room):
        dx, dy = you.pos[0] - self.pos[0], you.pos[1] - self.pos[1]
        d = sqrt(dx ** 2 + dy ** 2)
        r = uniform(100, 300)
        if d < r:
          self.setpursuit(you.pos)
        else:
          p = self.pos[0] + r * dx / d, self.pos[1] + r * dy / d
          self.setpursuit(p)
        self.patrolling = False
      elif self.patrolling:
        self.setpursuit(self.psteps[self.jpatrol])
        self.jpatrol = (self.jpatrol + 1) % len(self.psteps)
    thing.update(self, dt/2 if self.patrolling else dt)
    self.jwalk += dt
    if self.reeling:
      self.reeling = max(self.reeling - dt, 0)
    if self.nthrash and not self.reeling:
      self.reeling = 0.1
      self.nthrash -= 1
      alpha = uniform(0, 2 * pi)
      self.reeldir = sin(alpha), cos(alpha)
    if self.attacking:
      self.attacking = max(self.attacking - dt, 0)
    if self.tsleep:
      self.tsleep = max(self.tsleep - dt, 0)
    if self.humming:
      self.humming = max(self.humming - dt, 0)
    if self.tracer:
      self.tracer = max(self.tracer - dt, 0)
  def naptime(self):
    self.tsleep = 3
    self.pursuit = False
    self.attacking = 0
  @classmethod
  def loadimages(cls):
    cls.images = [rimage.Rimage(cls.dname, "p" + str(j) + "-") for j in range(cls.npic)]
    cls.loaded = True
    cls.rpic = cls.images[0].frame[0].get_width() / 2
  def draw(self, scr):
    scr.surf.blit(self.pic(), scr.pos((self.pos[0] - self.rpic, self.pos[1] - self.rpic)))
    self.drawharm(scr)
    self.drawsleep(scr)


class scorp(foe):
  loaded = False
  dname = "scorps"
  npic = 4
  wseq = (0, 1, 0, 2)
  wfcount = 10
  rseq = (0, 1, 0, 2)
  rfcount = 20
  aseq = (3, 0)
  afcount = 6
  atime = 2.
  def __init__(self, pos):
    if not scorp.loaded: scorp.loadimages()
    thing.__init__(self, pos, 28, 160, 2)
    self.attacking = 0
    self.jwalk = 0
    self.tsleep = 0
    self.humming = 0
    self.tracer = 0
    self.nthrash = 0

class boar(foe):
  loaded = False
  dname = "boar"
  npic = 7
  wseq = (0, 1, 0, 2)
  wfcount = 8
  rseq = (3, 0, 4, 0)
  rfcount = 15
  aseq = (5, 0, 6, 0, 5, 0, 6, 0) + (0,) * 17
  afcount = 8
  atime = 3.
  def __init__(self, pos):
    if not self.loaded: self.loadimages()
    thing.__init__(self, pos, 40, 160, 4)
    self.attacking = 0
    self.jwalk = 0
    self.tsleep = 0
    self.humming = 0
    self.tracer = 0
    self.nthrash = 0


class mine(foe):
  loaded = False
  dname = "mine"
  npic = 1
  def __init__(self, pos):
    if not self.loaded: self.loadimages()
    thing.__init__(self, pos, 20, 200, 100)
    self.attacking = 0
    self.jwalk = uniform(0, 3)
    self.tsleep = 0
    self.humming = 0
    self.tracer = 0
    self.nthrash = 0
  def attack(self, you):
    if you.tharm: return False
    you.harm(1, self)
  def update(self, dt, you, room):
    if self.humming:
      dt *= 3
    if not self.tsleep and not self.attacking and collide(self, you):
      self.attack(you)
    if not self.tsleep and not self.pursuit and not self.attacking:
      if self.patrolling:
        self.setpursuit(self.psteps[self.jpatrol])
        self.jpatrol = (self.jpatrol + 1) % len(self.psteps)
    thing.update(self, dt)
    self.jwalk += dt
    if self.tsleep:
      self.tsleep = max(self.tsleep - dt, 0)
    if self.humming:
      self.humming = max(self.humming - dt, 0)
  def pic(self):
    return self.images[0].getframe(self.jwalk / 2.)
  def harm(self, amt = 1, other = None):
    sound.playsound("dink")



