# Main game loopage

import pygame, data, screen, room, thing, spell, foe, dungeon, worldmap, dialog, sound
from pygame import *
from thing import *
from spell import *
from foe import *

def main():
  musicon = True
  mixer.pre_init(11025, -16, 1, 256)
  init()
  scr = screen.Screen((800, 500))
  display.set_caption("Wizburg")
  talky = dialog.dialog()
  clock = time.Clock()
  quitting = False
  while not quitting:
    if musicon:
      mixer.music.load(data.fpath("midi", "BATEAU.MID"))
      mixer.music.play()
    # Level select!
    choice, hp0, weapons = worldmap.choose(scr, talky)
    if musicon:
      mixer.music.stop()
    if not choice:
      quitting = True
      break
    playing = True
    dun = dungeon.dungeon(choice)
    you = wizard(dun.entrance)
    you.hp = you.hp0 = hp0
    for stype in weapons:
      if not stype.frame:
        stype.loadimages()
    jweap = 0
    if dun.musicname and musicon:
      mixer.music.load(data.fpath("midi", dun.musicname))
      mixer.music.play()
    washumming = False
    clock.tick()
    while playing and not quitting and you.alive:
      r = dun.room
      scr.setwallpaper(r.img)
      projs = []
      you.setpos(dun.entrance)
      if dun.issave(): you.hp = you.hp0

      # Transition into screen
      cover = surface.Surface((scr.x, scr.y)).convert_alpha()
      cticker = 0.5

      # Main screen action
      acting = True
      ofps = 0
      trac = None
      you.pursuit = None
      you.visible = False
      while acting:
        clock.tick(60)
        fps = clock.get_fps()
        if fps != ofps:
          ofps = fps
          print fps
        dt = clock.get_time() / 1000.
        e = event.get()
        kdowns = [x.key for x in e if x.type == KEYDOWN]
        if K_ESCAPE in kdowns: exit()
        if K_TAB in kdowns:
          if weapons:
            jweap = (jweap + 1) % len(weapons)
        for x in e:
          if x.type == MOUSEBUTTONDOWN:
            if x.button == 1 and you.cancast() and weapons:
              p = you.casttoward(scr.tpos(x.pos), r, weapons[jweap])
              projs.append(p)
              sound.playsound("cast")
              you.visible = True
            if x.button == 3:
              you.setpursuit(scr.tpos(x.pos))
              you.visible = True
            if x.button == 4 and weapons:
              jweap = (jweap - 1) % len(weapons)
            if x.button == 5 and weapons:
              jweap = (jweap + 1) % len(weapons)

        kpress = key.get_pressed()
        if you.tracer:
          t = you.trajtoward(scr.tpos(mouse.get_pos()), 300)
          trac = tracer(t, r.walls, you.tracer)

        upkeys = (K_UP, K_COMMA, K_w)
        downkeys = (K_DOWN, K_o, K_s)
        leftkeys = (K_LEFT, K_a)
        rightkeys = (K_RIGHT, K_e, K_d)
        wx, wy = 0, 0
        if any(kpress[k] for k in leftkeys): wx -= 1
        if any(kpress[k] for k in rightkeys): wx += 1
        if any(kpress[k] for k in upkeys): wy -= 1
        if any(kpress[k] for k in downkeys): wy += 1
        if kpress[K_m]:
          musicon = not musicon
          if musicon: mixer.music.play()
          if not musicon: mixer.music.stop()
        if wx or wy:
          you.visible = True
          if wx and wy: wx, wy = wx / sqrt(2), wy / sqrt(2)
          you.alpha = atan2(-wx, -wy) / (2 * pi)
	if you.humming: dt /= 3

        if you.humming and not washumming:
          sound.playsound("hum")
          if musicon: mixer.music.pause()
        if not you.humming and washumming:
          sound.playsound("unhum")
          if musicon: mixer.music.unpause()
        washumming = you.humming
        nsub = max(int(120 * dt), 1)
        dt /= nsub
        for j in range(nsub):
          if wx or wy:
            dwalk = dt * you.v
            if you.humming: dwalk *= 3
            if not you.tsleep:
              you.shift((dwalk * wx, dwalk * wy))
            you.pursuit = False
          you.update(dt)
          if not wx and not wy and not you.pursuit:
            you.jwalk = 0
          if not scr.onscreen(you.pos, you.r):
            acting = False
          r.constrain(you)
          for p in projs: p.update(dt)
          todel = []
          for j in range(len(projs)):
            ok = True
            if projs[j].age > 10.: ok = False
            if not scr.onscreen(projs[j].pos): ok = False
            if collide(projs[j], you):
              ok = False
              projs[j].afflict(you)
            for f in dun.foe:
              if collide(projs[j], f):
                ok = False
                projs[j].afflict(f)
            if not ok: todel.append(j)
          for j in reversed(todel):
             del projs[j]
          for j in reversed(range(len(dun.foe))):
            p = dun.foe[j].update(dt, you, r)
            if p: projs.append(p)
            if not dun.foe[j].alive: del dun.foe[j]
          for f in dun.foe: r.constrain(f)
        dt *= nsub


        if not you.alive: acting = False
        if dun.win(): acting = False

        scr.orient(you.pos)
        scr.clear()
        you.draw(scr)

        for p in projs: p.draw(scr)
        for f in dun.foe: f.draw(scr)
        for j in range(you.hp0):
          im = you.heart1 if you.hp > j else you.heart0
          scr.surf.blit(im, (16 + j*32, 16))
        if you.tracer and trac: trac.draw(scr)
        if weapons:
          scr.surf.blit(weapons[jweap].icon, (8, 54))
          scr.surf.blit(weapons[jweap].caption, (80, 54))
        # Transition in
        if cticker:
          cticker = max(cticker - dt, 0)
          cover.fill((0, 0, 0, int(500 * cticker)))
          scr.surf.blit(cover, (0, 0))
          if not cticker:
            d = dun.getdialog()
            if d != -1: talky.hold(scr, d)
            clock.tick()
            if dun.currentroomn + 1 == len(dun.roomdata) and musicon:
              mixer.music.stop()
              mixer.music.load(data.fpath("midi", "ARENE01.MID"))
              mixer.music.play()
        display.flip()
      if musicon: mixer.fadeout(500)

      if dun.win():
        talky.hold(scr, dun.dend)
        clock.tick()
        playing = False
      # Transition out of screen
      t = 0.5
      s = Surface(scr.surf.get_size()).convert_alpha()
      s.fill((0, 0, 0, 40) if you.alive else (255, 0, 0, 40))
      while t >= 0:
        clock.tick(40)
        t -= clock.get_time() / 1000.
        scr.surf.blit(s, (0, 0))
        display.flip()
#      if not you.alive: quitting = True
      if not scr.onscreen(you.pos, you.r):
        dun.exitroom(scr.whichdir(you.pos, you.r))
      if dun.currentroomn == -1: quitting = True
      if dun.win(): dun.setwin()

