import pygame, data, math, spell, wallseg
from wallseg import *
from pygame import *
from math import *
from spell import *

class Room:
  def __init__(self, name):
    self.name = name
    self.img = data.loadimg("rooms", name + ".png")
    self.getdata()
  def getdata(self):
    self.walls = []
    self.entrance = []
    self.patrol = []
    for line in data.load("dungeon", self.name + ".dat").readlines():
      c = line[0]
      line = line[2:]
      ps = [int(s) for s in line.split(" ") if len(line) > 6]
      if c == "e":
        for j in range(len(ps)/2):
          self.entrance.append((ps[2*j], ps[2*j+1]))
      elif c == "w":
        for j in range(len(ps)/2 - 1):
          x0, y0, x1, y1 = ps[j*2:j*2+4]
          self.walls.append(wallseg((x0, y0), (x1, y1)))
      elif c == "p":
        pat = []
        for j in range(len(ps)/2):
          pat.append((ps[2*j], ps[2*j+1]))
        self.patrol.append(pat)
  def constrain(self, s):
    tocheck = True
    while tocheck:
      dmin = None
      for w in self.walls:
        d = w.dtosprite(s)
        if d is not None and (dmin is None or d < dmin):
          dmin, wmin = d, w
      tocheck = dmin is not None and dmin < s.r
      if tocheck:
        d = 1.001 * s.r - dmin
        s.shift(wmin.scootsprite(s, d))
        s.pursuit = None




