import pygame, math, random, trajectory
from pygame import *
from math import *
from random import *
from trajectory import *


class wallseg:
  def __init__(self, p0, p1):
    (self.x0, self.y0), (self.x1, self.y1) = self.p0, self.p1 = p0, p1
    self.dx, self.dy = self.d = self.x1 - self.x0, self.y1 - self.y0
    self.dmag2 = float(self.dx ** 2 + self.dy ** 2)
    self.dmag = sqrt(self.dmag2)
    self.dhatx, self.dhaty = self.dx / self.dmag, self.dy / self.dmag
    self.det = self.x1 * self.y0 - self.y1 * self.x0
    self.p0dhat = self.x0 * self.dhatx + self.y0 * self.dhaty
    self.C, self.S = self.dx / self.dmag, self.dy / self.dmag
    self.C2 = (self.dx ** 2 - self.dy ** 2) / self.dmag2
    self.S2 = 2 * self.dx * self.dy / self.dmag2
  def dpoint(self, (x, y)):
    num = self.dx * (self.y1 - y) - self.dy * (self.x1 - x)
    return num / self.dmag
  def bounce(self, (x, y)):
    return self.C2 * x + self.S2 * y, -self.C2 * y + self.S2 * x
  def catchtraj(self, t):
    dp = self.dpoint(t.r)
    if dp < 0: return None
    dp2 = self.dpoint(t.rp)
    if dp2 >= dp: return None
    time = dp / (dp - dp2)
    ax, ay = t.at(time)
    k = self.dhatx * ax + self.dhaty * ay - self.p0dhat
    if k < 0 or k >= self.dmag: return None
    return time, trajectory((ax, ay), self.bounce(t.v))
#    den = t.vx * self.dy - t.vy * self.dx
#    num = self.det + t.rx * self.dy - t.ry * self.dx
  def dtosprite(self, s, dmax2 = None):
    dx, dy = s.px - self.x0, s.py - self.y0
    tdx = dx * self.C + dy * self.S
    if tdx > self.dmag: return None
    if tdx < 0:
      d2 = dx ** 2 + dy ** 2
      if dmax2 is not None and d2 > dmax2: return None
      return sqrt(d2)
    return abs(dy * self.C - dx * self.S)
  def scootsprite(self, s, d):
    dx, dy = s.px - self.x0, s.py - self.y0
    tdx = dx * self.C + dy * self.S
    if tdx > self.dmag: return None
    if tdx < 0:
      dist = sqrt(dx ** 2 + dy ** 2)
      return d * dx / dist, d * dy / dist
    return d * self.dhaty, -d * self.dhatx
  def draw(self, scr):
    draw.line(scr.surf, (255, 255, 255), scr.pos(self.p0), scr.pos(self.p1))
    draw.circle(scr.surf, (255, 0, 255), scr.pos(self.p0), 4)


