import pygame, data, spell
from pygame import *
from data import *
from spell import *

class castle:
  lockpic = None
  def __init__(self, (ax, ay), iname, title, scr, completed = False, locked = True):
    self.iname = iname
    self.pos = int(scr.x * ax), int(scr.y * ay)
    self.image = data.loadimg("castles", iname + ".png")
    self.irect = self.image.get_rect()
    self.irect.center = self.pos
    self.title = title
    if not self.lockpic:
      castle.lockpic = data.loadimg("lock.png")  # Get it? Lock pic? Har.
    self.locked = locked
    self.completed = completed
    if self.completed:
      self.title += " [COMPLETED]"
  def setlocked(self):
    if self.locked:
      self.title += " [LOCKED]"
      self.lrect = castle.lockpic.get_rect()
      self.lrect.center = self.irect.center
  def maketitle(self, font):
    self.tsurf = font.render(self.title, True, (255, 255, 255))
  def makebimage():
    self.bimage = surface.Surface(self.image.get_size()).convert_alpha()
    m = lambda x: int(255 - (255 - x) / 2)
    for x in range(self.irect.width):
      for y in range(self.irect.height):
        r, g, b, a = self.image.get_at((x, y))
        self.bimage.set_at((x, y), (m(r), m(g), m(b), a))
  def draw(self, scr):
    scr.surf.blit(self.image, self.irect)
    if self.locked:
      scr.surf.blit(self.lockpic, self.lrect)
  def drawtitle(self, scr):
    r = self.tsurf.get_rect()
    r.midbottom = scr.x / 2, scr.y - 10
    scr.surf.blit(self.tsurf, r)
  def hit(self, (px, py)):
    x0, y0 = self.irect.topleft
    x, y = px - x0, py - y0
    if not 0 <= x < self.irect.width: return False
    if not 0 <= y < self.irect.height: return False
    alpha = self.image.get_at((x, y))[3]
    return alpha > 128

def choose(scr, di):
  cs = []

  hp = 3
  comp = []
  try:
    f = data.load("savegame.dat")
    for line in f:
      if not "|" in line: continue
      dname, r, e = line[:-1].split("|")
      if r == "-1":
        comp.append(dname)
        hp += 1
  except IOError:
    di.hold(scr, 0)
  print comp

  for line in data.load("dungeon", "worldmap.dat"):
    ws = line[0:-1].split(" ")
    if len(ws) < 3: continue
    p = float(ws[1]), float(ws[2])
    title = " ".join(ws[3:])
    cs.append(castle(p, ws[0], title, scr, ws[0] in comp))
  cs[0].locked = False
  for j in (1, 2, 3, 4): cs[j].locked = not cs[0].completed
  cs[5].locked = not all(cs[j].completed for j in (1, 2, 3, 4))
  cs[6].locked = not cs[5].completed
  if cs[6].completed: exit()

#  for c in cs: c.locked = False  # IMPORTAN! REMOV!
#  for c in cs: c.completed = False  # IMPORTAN! REMOV!

  for c in cs: c.setlocked()
  font.init()
  f = font.SysFont("freeserif	", 40)
  s1 = f.render("Select", True, (255, 255, 255))
  s2 = f.render("Level", True, (255, 255, 255))
  for c in cs: c.maketitle(f)
  allspell = (fspell, dspell, ospell, hspell, rspell, pspell)
  spellsugot = []
  for j in range(6):
    if cs[j].completed: spellsugot.append(allspell[j])

#  spellsugot = allspell   # REMOVE BOYEEEE!

  clock = time.Clock()
  while 1:
    clock.tick(60)
    e = event.get()
    kdowns = [x.key for x in e if x.type == KEYDOWN]
    if K_ESCAPE in kdowns: exit()
    for x in e:
      if x.type == MOUSEBUTTONDOWN:
        for c in cs:
          if c.hit(x.pos):
            if not c.locked and not c.completed:
              return c.iname, hp, spellsugot
    scr.surf.fill((0,0,255,0))
    scr.surf.blit(s1, (12, 12))
    scr.surf.blit(s2, (24, 56))
    if not cs[-1].locked: cs[-1].draw(scr)
    for c in reversed(cs[:-1]):
      c.draw(scr)
    for c in cs:
      if c.hit(mouse.get_pos()) and (c != cs[-1] or not c.locked):
        c.drawtitle(scr)
        break
    display.flip()




